/*
 * generated by Xtext 2.25.0
 */
package org.xtext.example.methodname.serializer;

import com.google.inject.Inject;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.acceptor.SequenceFeeder;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import org.eclipse.xtext.serializer.sequencer.ITransientValueService.ValueTransient;
import org.xtext.example.methodname.methodName.And;
import org.xtext.example.methodname.methodName.Case;
import org.xtext.example.methodname.methodName.Declaration;
import org.xtext.example.methodname.methodName.FixedDeclaration;
import org.xtext.example.methodname.methodName.GroupExpr;
import org.xtext.example.methodname.methodName.MethodNamePackage;
import org.xtext.example.methodname.methodName.Model;
import org.xtext.example.methodname.methodName.Or;
import org.xtext.example.methodname.methodName.POSValue;
import org.xtext.example.methodname.methodName.Property;
import org.xtext.example.methodname.methodName.Rule;
import org.xtext.example.methodname.methodName.StringConst;
import org.xtext.example.methodname.methodName.SynonymConst;
import org.xtext.example.methodname.services.MethodNameGrammarAccess;

@SuppressWarnings("all")
public class MethodNameSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private MethodNameGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == MethodNamePackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case MethodNamePackage.AND:
				sequence_And(context, (And) semanticObject); 
				return; 
			case MethodNamePackage.CASE:
				sequence_Case(context, (Case) semanticObject); 
				return; 
			case MethodNamePackage.DECLARATION:
				sequence_Declaration(context, (Declaration) semanticObject); 
				return; 
			case MethodNamePackage.FIXED_DECLARATION:
				sequence_FixedDeclaration(context, (FixedDeclaration) semanticObject); 
				return; 
			case MethodNamePackage.GROUP_EXPR:
				sequence_GroupExpr(context, (GroupExpr) semanticObject); 
				return; 
			case MethodNamePackage.MODEL:
				sequence_Model(context, (Model) semanticObject); 
				return; 
			case MethodNamePackage.OR:
				sequence_Or(context, (Or) semanticObject); 
				return; 
			case MethodNamePackage.POS_VALUE:
				sequence_Atomic(context, (POSValue) semanticObject); 
				return; 
			case MethodNamePackage.PROPERTY:
				sequence_Property(context, (Property) semanticObject); 
				return; 
			case MethodNamePackage.RULE:
				sequence_Rule(context, (Rule) semanticObject); 
				return; 
			case MethodNamePackage.STRING_CONST:
				sequence_Atomic(context, (StringConst) semanticObject); 
				return; 
			case MethodNamePackage.SYNONYM_CONST:
				sequence_Atomic(context, (SynonymConst) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     Expr returns And
	 *     Or returns And
	 *     Or.Or_1_0 returns And
	 *     And returns And
	 *     And.And_1_0 returns And
	 *
	 * Constraint:
	 *     (left=And_And_1_0 (concatKind='.' | concatKind='...') right=Primary)
	 */
	protected void sequence_And(ISerializationContext context, And semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Expr returns POSValue
	 *     Or returns POSValue
	 *     Or.Or_1_0 returns POSValue
	 *     And returns POSValue
	 *     And.And_1_0 returns POSValue
	 *     Primary returns POSValue
	 *     Atomic returns POSValue
	 *
	 * Constraint:
	 *     (hasNot?='!'? pos=POS card=CardinalityModifier? sentiment=Sentiment?)
	 */
	protected void sequence_Atomic(ISerializationContext context, POSValue semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Expr returns StringConst
	 *     Or returns StringConst
	 *     Or.Or_1_0 returns StringConst
	 *     And returns StringConst
	 *     And.And_1_0 returns StringConst
	 *     Primary returns StringConst
	 *     Atomic returns StringConst
	 *
	 * Constraint:
	 *     (hasNot?='!'? value=STRING card=CardinalityModifier? sentiment=Sentiment?)
	 */
	protected void sequence_Atomic(ISerializationContext context, StringConst semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Expr returns SynonymConst
	 *     Or returns SynonymConst
	 *     Or.Or_1_0 returns SynonymConst
	 *     And returns SynonymConst
	 *     And.And_1_0 returns SynonymConst
	 *     Primary returns SynonymConst
	 *     Atomic returns SynonymConst
	 *
	 * Constraint:
	 *     (hasNot?='!'? value=STRING card=CardinalityModifier? sentiment=Sentiment?)
	 */
	protected void sequence_Atomic(ISerializationContext context, SynonymConst semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Case returns Case
	 *
	 * Constraint:
	 *     (kind=Kind condition=Expr properties+=Property*)
	 */
	protected void sequence_Case(ISerializationContext context, Case semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Declaration returns Declaration
	 *
	 * Constraint:
	 *     (name=ID path=STRING)
	 */
	protected void sequence_Declaration(ISerializationContext context, Declaration semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, MethodNamePackage.Literals.DECLARATION__NAME) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, MethodNamePackage.Literals.DECLARATION__NAME));
			if (transientValues.isValueTransient(semanticObject, MethodNamePackage.Literals.DECLARATION__PATH) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, MethodNamePackage.Literals.DECLARATION__PATH));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getDeclarationAccess().getNameIDTerminalRuleCall_0_0(), semanticObject.getName());
		feeder.accept(grammarAccess.getDeclarationAccess().getPathSTRINGTerminalRuleCall_2_0(), semanticObject.getPath());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     FixedDeclaration returns FixedDeclaration
	 *
	 * Constraint:
	 *     (kind=Kind path=STRING)
	 */
	protected void sequence_FixedDeclaration(ISerializationContext context, FixedDeclaration semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, MethodNamePackage.Literals.FIXED_DECLARATION__KIND) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, MethodNamePackage.Literals.FIXED_DECLARATION__KIND));
			if (transientValues.isValueTransient(semanticObject, MethodNamePackage.Literals.FIXED_DECLARATION__PATH) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, MethodNamePackage.Literals.FIXED_DECLARATION__PATH));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getFixedDeclarationAccess().getKindKindEnumRuleCall_0_0(), semanticObject.getKind());
		feeder.accept(grammarAccess.getFixedDeclarationAccess().getPathSTRINGTerminalRuleCall_2_0(), semanticObject.getPath());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Expr returns GroupExpr
	 *     Or returns GroupExpr
	 *     Or.Or_1_0 returns GroupExpr
	 *     And returns GroupExpr
	 *     And.And_1_0 returns GroupExpr
	 *     Primary returns GroupExpr
	 *     GroupExpr returns GroupExpr
	 *
	 * Constraint:
	 *     (hasNot?='!'? expr=Expr card=CardinalityModifier?)
	 */
	protected void sequence_GroupExpr(ISerializationContext context, GroupExpr semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Model returns Model
	 *
	 * Constraint:
	 *     (declarations+=Declaration* fixedDeclarations+=FixedDeclaration+ rules+=Rule* elements+=Case*)
	 */
	protected void sequence_Model(ISerializationContext context, Model semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Expr returns Or
	 *     Or returns Or
	 *     Or.Or_1_0 returns Or
	 *
	 * Constraint:
	 *     (left=Or_Or_1_0 right=And)
	 */
	protected void sequence_Or(ISerializationContext context, Or semanticObject) {
		if (errorAcceptor != null) {
			if (transientValues.isValueTransient(semanticObject, MethodNamePackage.Literals.OR__LEFT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, MethodNamePackage.Literals.OR__LEFT));
			if (transientValues.isValueTransient(semanticObject, MethodNamePackage.Literals.OR__RIGHT) == ValueTransient.YES)
				errorAcceptor.accept(diagnosticProvider.createFeatureValueMissing(semanticObject, MethodNamePackage.Literals.OR__RIGHT));
		}
		SequenceFeeder feeder = createSequencerFeeder(context, semanticObject);
		feeder.accept(grammarAccess.getOrAccess().getOrLeftAction_1_0(), semanticObject.getLeft());
		feeder.accept(grammarAccess.getOrAccess().getRightAndParserRuleCall_1_2_0(), semanticObject.getRight());
		feeder.finish();
	}
	
	
	/**
	 * Contexts:
	 *     Property returns Property
	 *
	 * Constraint:
	 *     (frequency=Frequency? criterion=[Rule|ID])
	 */
	protected void sequence_Property(ISerializationContext context, Property semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Rule returns Rule
	 *
	 * Constraint:
	 *     (
	 *         (
	 *             name=ID 
	 *             kind=Kind 
	 *             decls+=[Declaration|ID] 
	 *             decls+=[Declaration|ID]* 
	 *             (compOp='>' | compOp='<' | compOp='==' | compOp='<=' | compOp='>=') 
	 *             compValue=INT
	 *         ) | 
	 *         name=ID
	 *     )
	 */
	protected void sequence_Rule(ISerializationContext context, Rule semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
